# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetObjectStoreResult',
    'AwaitableGetObjectStoreResult',
    'get_object_store',
    'get_object_store_output',
]

@pulumi.output_type
class GetObjectStoreResult:
    """
    A collection of values returned by getObjectStore.
    """
    def __init__(__self__, access_key_id=None, endpoint=None, generated_name=None, id=None, max_size_gb=None, name=None, region=None, secret_access_key=None, status=None):
        if access_key_id and not isinstance(access_key_id, str):
            raise TypeError("Expected argument 'access_key_id' to be a str")
        pulumi.set(__self__, "access_key_id", access_key_id)
        if endpoint and not isinstance(endpoint, str):
            raise TypeError("Expected argument 'endpoint' to be a str")
        pulumi.set(__self__, "endpoint", endpoint)
        if generated_name and not isinstance(generated_name, str):
            raise TypeError("Expected argument 'generated_name' to be a str")
        pulumi.set(__self__, "generated_name", generated_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if max_size_gb and not isinstance(max_size_gb, int):
            raise TypeError("Expected argument 'max_size_gb' to be a int")
        pulumi.set(__self__, "max_size_gb", max_size_gb)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if secret_access_key and not isinstance(secret_access_key, str):
            raise TypeError("Expected argument 'secret_access_key' to be a str")
        pulumi.set(__self__, "secret_access_key", secret_access_key)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="accessKeyId")
    def access_key_id(self) -> str:
        return pulumi.get(self, "access_key_id")

    @property
    @pulumi.getter
    def endpoint(self) -> str:
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter(name="generatedName")
    def generated_name(self) -> str:
        return pulumi.get(self, "generated_name")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxSizeGb")
    def max_size_gb(self) -> Optional[int]:
        return pulumi.get(self, "max_size_gb")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="secretAccessKey")
    def secret_access_key(self) -> str:
        return pulumi.get(self, "secret_access_key")

    @property
    @pulumi.getter
    def status(self) -> str:
        return pulumi.get(self, "status")


class AwaitableGetObjectStoreResult(GetObjectStoreResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetObjectStoreResult(
            access_key_id=self.access_key_id,
            endpoint=self.endpoint,
            generated_name=self.generated_name,
            id=self.id,
            max_size_gb=self.max_size_gb,
            name=self.name,
            region=self.region,
            secret_access_key=self.secret_access_key,
            status=self.status)


def get_object_store(id: Optional[str] = None,
                     max_size_gb: Optional[int] = None,
                     name: Optional[str] = None,
                     region: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetObjectStoreResult:
    """
    Get information of an Object Store for use in other resources. This data source provides all of the Object Store's properties as configured on your Civo account.

    Note: This data source returns a single Object Store. When specifying a name, an error will be raised if more than one Object Stores with the same name found.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['maxSizeGb'] = max_size_gb
    __args__['name'] = name
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('civo:index/getObjectStore:getObjectStore', __args__, opts=opts, typ=GetObjectStoreResult).value

    return AwaitableGetObjectStoreResult(
        access_key_id=__ret__.access_key_id,
        endpoint=__ret__.endpoint,
        generated_name=__ret__.generated_name,
        id=__ret__.id,
        max_size_gb=__ret__.max_size_gb,
        name=__ret__.name,
        region=__ret__.region,
        secret_access_key=__ret__.secret_access_key,
        status=__ret__.status)


@_utilities.lift_output_func(get_object_store)
def get_object_store_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                            max_size_gb: Optional[pulumi.Input[Optional[int]]] = None,
                            name: Optional[pulumi.Input[Optional[str]]] = None,
                            region: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetObjectStoreResult]:
    """
    Get information of an Object Store for use in other resources. This data source provides all of the Object Store's properties as configured on your Civo account.

    Note: This data source returns a single Object Store. When specifying a name, an error will be raised if more than one Object Stores with the same name found.
    """
    ...
